# Magento Testing Framework

Magento Testing Framework (MTF) is an open source R&D project facilitating the improvement of Magento Core products. Magento Testing Framework helps in avoiding duplication of test cases automated across the application utilizing data driven approach. With the new and improved Magento Testing Framework, developers will be able to automate functional testing of the developed functionality enabling frequent releases and higher product quality.

For more overview information refer to [Introduction to Magento Testing Framework](http://devdocs.magento.com/guides/v2.0/mtf/mtf_introduction.html).

<h2>Step 1: Check your pre-installation conditions</h2>

Before installing the MTF, you will need to [configure Magento to prepare for testing](http://devdocs.magento.com/guides/v2.0/mtf/mtf_installation.html#mtf_install_pre_adj-magento), and [verify that required software is installed](http://devdocs.magento.com/guides/v2.0/mtf/mtf_installation.html#mtf_install_pre_tools). 
<h2>Step 2: Install the MTF</h2>

When you're ready, use [Composer to install the MTF](http://devdocs.magento.com/guides/v2.0/mtf/mtf_installation.html#mtf_install_perform).

<h2>Step 3: Verify your installation</h2>

[Verify that MTF is installed](http://devdocs.magento.com/guides/v2.0/mtf/mtf_installation.html#mtf_install_check)  by checking your <code>dev/tests/functional/</code> directory to look for `vendor/magento/mtf`.

<h2>Step 4: Get Started with testing</h2>

For a fast-path option, see the [Quick start steps](http://devdocs.magento.com/guides/v2.0/mtf/mtf_quickstart.html). There you will learn how to [configure PHPUnit](http://devdocs.magento.com/guides/v2.0/mtf/mtf_quickstart/mtf_quickstart_config.html), [set up Selenium](http://devdocs.magento.com/guides/v2.0/mtf/mtf_quickstart/mtf_quickstart_environmemt.html) and [run functional tests](http://devdocs.magento.com/guides/v2.0/mtf/mtf_quickstart/mtf_quickstart_runtest.html).

<h2>Contributing to the Magento Testing Framework code base</h2>

Contributions can take the form of new components or features, changes to existing features, tests, documentation (such as developer guides, user guides, examples, or specifications), bug fixes, optimizations, or just good suggestions.

To contribute to the MTF code base, you can use [general guides of Magento 2 contributing][1].

To open an issue, click [here][2].

[1]: <http://devdocs.magento.com/guides/v2.0/contributor-guide/contributing.html>
[2]: <https://github.com/magento/mtf/issues>